src/main/java/dw2/tema6/system/model/Activity.java
package dw2.tema6.system.model;

import javax.persistence.Entity;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Transient;

@Entity
public class Activity {
	
	public enum Status {
		TO_DO,
		DOING,
		TO_APPROVE,
		REJECTED,
		DONE;
		
		public Boolean getCanBegin() {
			return this == Status.TO_DO || this == Status.REJECTED;
		}

		public Boolean getCanFinishOrCancel() {
			return this == Status.DOING;
		}

		public Boolean getCanApproveOrDisapprove() {
			return this == Status.TO_APPROVE;
		}
	}
	
	@Id
	@GeneratedValue
	private long code;
	private String description;
	private String estimatedDuration;
	
	@Enumerated
	private Status status = Status.TO_DO;
	
	@ManyToOne
	private Analyst analyst;
	
	@ManyToOne
	private System system;

	public long getCode() {
		return code;
	}

	public void setCode(long code) {
		this.code = code;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getEstimatedDuration() {
		return estimatedDuration;
	}

	public void setEstimatedDuration(String estimatedDuration) {
		this.estimatedDuration = estimatedDuration;
	}

	public Status getStatus() {
		return status;
	}

	public void setStatus(Status status) {
		this.status = status;
	}

	public Analyst getAnalyst() {
		return analyst;
	}

	public void setAnalyst(Analyst analyst) {
		this.analyst = analyst;
	}

	public System getSystem() {
		return system;
	}

	public void setSystem(System system) {
		this.system = system;
	}
	
	/**
	 * @return the completion percentage based on current {@link #status} ranging from 0 to 1
	 * @see Status
	 */
	@Transient
	public Float getProgress() {
		switch (status) {
		case DOING:
			return 1f / 3;
			
		case TO_APPROVE:
			return 2f / 3;
			
		case DONE:
			return 1f;

		default:
			return 0f;
		}
	}
}

src/main/java/dw2/tema6/system/model/Analyst.java
package dw2.tema6.system.model;

import java.util.List;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.Transient;

import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;

import dw2.tema6.common.model.User;

@Entity
public class Analyst extends User {
	
	@OneToMany(mappedBy="analyst", fetch = FetchType.EAGER)
	@Fetch(FetchMode.SUBSELECT)
	private List<Activity> activities;

	public List<Activity> getActivities() {
		return activities;
	}

	public void setActivities(List<Activity> activities) {
		this.activities = activities;
	}
	
	/**
	 * @return the tasks completion percentage based on {@link #activities} progress average ranging from 0 to 1
	 * @see Activity
	 */
	@Transient
	public Float getActivitiesProgress() {
		if (activities.size() == 0) return 0f;
		Float progressSum = 0f;
		for (Activity activity : activities) {
			progressSum += activity.getProgress();
		}
		return progressSum / activities.size();
	}
	
	@Override
	public boolean equals(Object obj) {
		if (super.equals(obj)) return true;
		if (obj.getClass() != this.getClass()) return false;
		if (getCode() != ((Analyst) obj).getCode()) return false;
		return true;
	}
}

src/main/java/dw2/tema6/system/controller/ActivityListController.java
package dw2.tema6.system.controller;

import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import dw2.tema6.auth.controller.AuthController;
import dw2.tema6.common.PersistenceManager;
import dw2.tema6.project.model.Coordinator;
import dw2.tema6.project.model.Project;
import dw2.tema6.system.model.Activity;
import dw2.tema6.system.model.Analyst;

@ManagedBean
@ViewScoped
public class ActivityListController {
	public List<Activity> getMyActivities() {
		Analyst analyst = (Analyst) AuthController.getLoggedUser();
		return analyst.getActivities();
	}
}

src/main/webapp/WEB-INF/analyst/activity_list.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:ui="http://java.sun.com/jsf/facelets">

	<h:dataTable value="#{activityListController.myActivities}" var="act"
		border="1" cellpadding="2" cellspacing="0">>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.activity_code}" />
			</f:facet>
			<h:outputLabel value="#{act.code}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.description}" />
			</f:facet>
			<h:outputLabel value="#{act.description}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.estimated_duration}" />
			</f:facet>
			<h:outputLabel value="#{act.estimatedDuration}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.status}" />
			</f:facet>
			<h:outputLabel value="#{strings[act.status]}" />
		</h:column>
		<h:column>
			<h:form>
				<h:commandButton value="#{strings.begin}"
					action="#{activityWorkflowController.begin}"
					rendered="#{act.status.canBegin}">
					<f:setPropertyActionListener
						target="#{activityWorkflowController.activity}" value="#{act}" />
				</h:commandButton>

				<h:panelGroup id="finish_cancel_buttons"
					rendered="#{act.status.canFinishOrCancel}">
					<h:commandButton value="#{strings.finish}"
						action="#{activityWorkflowController.finish}">
						<f:setPropertyActionListener
							target="#{activityWorkflowController.activity}" value="#{act}" />
					</h:commandButton>

					<h:commandButton value="#{strings.cancel}"
						action="#{activityWorkflowController.cancel}">
						<f:setPropertyActionListener
							target="#{activityWorkflowController.activity}" value="#{act}" />
					</h:commandButton>
				</h:panelGroup>
			</h:form>
		</h:column>
	</h:dataTable>
</ui:composition>